<template>
    <ion-menu content-id="main-content" type="overlay">
        <ion-content>
            <ion-list id="inbox-list">
                <ion-list-header>WiFi IoT</ion-list-header>
                <ion-note>ZČU</ion-note>

                <ion-item-group v-if="user.logged">
                    <ion-menu-toggle :auto-hide="false">
                        <ion-item
                            router-direction="root"
                            @click="redirect(Route.home)"
                            :class="{
                                selected: global.selectedMenu === Route.home,
                            }"
                            lines="none"
                            class="hydrated"
                        >
                            <ion-icon
                                aria-hidden="true"
                                slot="start"
                                :ios="home"
                                :md="home"
                            ></ion-icon>
                            <ion-label>Domů</ion-label>
                        </ion-item>
                    </ion-menu-toggle>

                    <ion-menu-toggle :auto-hide="false">
                        <ion-item
                            router-direction="root"
                            @click="redirect(Route.deviceList)"
                            :class="{
                                selected:
                                    global.selectedMenu === Route.deviceList,
                            }"
                            lines="none"
                            class="hydrated"
                        >
                            <ion-icon
                                aria-hidden="true"
                                slot="start"
                                :ios="radio"
                                :md="radio"
                            ></ion-icon>
                            <ion-label>Zařízení</ion-label>
                        </ion-item>
                    </ion-menu-toggle>

                    <ion-menu-toggle :auto-hide="false">
                        <ion-item
                            router-direction="root"
                            @click="redirect(Route.groupList)"
                            :class="{
                                selected:
                                    global.selectedMenu === Route.groupList,
                            }"
                            lines="none"
                            class="hydrated"
                        >
                            <ion-icon
                                aria-hidden="true"
                                slot="start"
                                :ios="layers"
                                :md="layers"
                            ></ion-icon>
                            <ion-label>Skupiny</ion-label>
                        </ion-item>
                    </ion-menu-toggle>
                </ion-item-group>

                <ion-item-group v-if="user.logged && user.data.isAdmin">
                    <ion-menu-toggle :auto-hide="false">
                        <ion-item
                            router-direction="root"
                            @click="redirect(Route.userList)"
                            :class="{
                                selected:
                                    global.selectedMenu === Route.userList,
                            }"
                            lines="none"
                            class="hydrated"
                        >
                            <ion-icon
                                aria-hidden="true"
                                slot="start"
                                :ios="people"
                                :md="people"
                            ></ion-icon>
                            <ion-label>Uživatelé</ion-label>
                        </ion-item>
                    </ion-menu-toggle>

                    <ion-menu-toggle :auto-hide="false">
                        <ion-item
                            router-direction="root"
                            @click="redirect(Route.staticIpList)"
                            :class="{
                                selected:
                                    global.selectedMenu === Route.staticIpList,
                            }"
                            lines="none"
                            class="hydrated"
                        >
                            <ion-icon
                                aria-hidden="true"
                                slot="start"
                                :ios="planet"
                                :md="planet"
                            ></ion-icon>
                            <ion-label>Veřejné adresy</ion-label>
                        </ion-item>
                    </ion-menu-toggle>
                </ion-item-group>

                <ion-item-group>
                    <ion-item-divider>
                        <ion-label>
                            <ion-icon
                                aria-hidden="true"
                                :ios="person"
                                :md="person"
                            ></ion-icon>
                            {{
                                user.logged
                                    ? user.data.name
                                    : 'Nepřihlášený uživatel'
                            }}
                        </ion-label>
                    </ion-item-divider>

                    <ion-menu-toggle :auto-hide="false" v-if="user.logged">
                        <ion-item
                            router-direction="root"
                            @click="redirect(Route.me)"
                            :class="{
                                selected: global.selectedMenu === Route.me,
                            }"
                            lines="none"
                            class="hydrated"
                        >
                            <ion-icon
                                aria-hidden="true"
                                slot="start"
                                :ios="terminal"
                                :md="terminal"
                            ></ion-icon>
                            <ion-label>Aktivní přihlášení</ion-label>
                        </ion-item>
                    </ion-menu-toggle>

                    <ion-menu-toggle :auto-hide="false" v-if="user.logged">
                        <ion-item
                            router-direction="root"
                            @click="logout"
                            lines="none"
                            class="hydrated"
                        >
                            <ion-icon
                                aria-hidden="true"
                                slot="start"
                                :ios="logOut"
                                :md="logOut"
                            ></ion-icon>
                            <ion-label>Odhlásit se</ion-label>
                        </ion-item>
                    </ion-menu-toggle>
                </ion-item-group>

                <ion-item-group>
                    <ion-item-divider>
                        <ion-label> Vzhled </ion-label>
                    </ion-item-divider>

                    <ion-item>
                        <ion-toggle
                            :checked="paletteToggle"
                            @ionChange="toggleChange($event)"
                            justify="space-between"
                            >Tmavý mód</ion-toggle
                        >
                    </ion-item>
                </ion-item-group>
            </ion-list>
        </ion-content>
    </ion-menu>
</template>

<script setup lang="ts">
import {
    home,
    radio,
    logOut,
    person,
    people,
    planet,
    terminal,
    layers,
} from 'ionicons/icons'

import {
    IonItemGroup,
    IonToggle,
    IonItemDivider,
    IonContent,
    IonIcon,
    IonItem,
    IonLabel,
    IonList,
    IonListHeader,
    IonMenu,
    IonMenuToggle,
    IonNote,
    ToggleCustomEvent,
} from '@ionic/vue'

import { useUserStore } from '@/stores/userStore'
import router from '@/router'
import { Route } from '@/router/route'
import { ref } from 'vue'
import { useGlobalStore } from '@/stores/globalStore'

const user = useUserStore()
const global = useGlobalStore()

const logout = () => {
    user.logOut().then(() => {
        router.push({ name: Route.login })
    })
}
const redirect = (name: string) => {
    global.selectedMenu = name
    router.push({ name })
}

// Tmavý režim
const globalStore = useGlobalStore()

const paletteToggle = ref(globalStore.darkMode)

const toggleChange = (ev: ToggleCustomEvent) =>
    globalStore.darkModeOn(ev.detail.checked)
</script>

<style scoped>
ion-menu ion-content {
    --background: var(--ion-item-background, var(--ion-background-color, #fff));
}

ion-menu.md ion-content {
    --padding-start: 8px;
    --padding-end: 8px;
    --padding-top: 20px;
    --padding-bottom: 20px;
}

ion-menu.md ion-list {
    padding: 20px 0;
}

ion-menu.md ion-note {
    margin-bottom: 30px;
}

ion-menu.md ion-list-header,
ion-menu.md ion-note {
    padding-left: 10px;
}

ion-menu.md ion-list#inbox-list {
    border-bottom: 1px solid var(--ion-color-step-150, #d7d8da);
}

ion-menu.md ion-list#inbox-list ion-list-header {
    font-size: 22px;
    font-weight: 600;

    min-height: 20px;
}

ion-menu.md ion-list#labels-list ion-list-header {
    font-size: 16px;

    margin-bottom: 18px;

    color: #757575;

    min-height: 26px;
}

ion-menu.md ion-item {
    --padding-start: 10px;
    --padding-end: 10px;
    border-radius: 4px;
}

ion-menu.md ion-item.selected {
    --background: rgba(var(--ion-color-primary-rgb), 0.14);
}

ion-menu.md ion-item.selected ion-icon {
    color: var(--ion-color-primary);
}

ion-menu.md ion-item ion-icon {
    color: #616e7e;
}

ion-menu.md ion-item ion-label {
    font-weight: 500;
}

ion-menu.ios ion-content {
    --padding-bottom: 20px;
}

ion-menu.ios ion-list {
    padding: 20px 0 0 0;
}

ion-menu.ios ion-note {
    line-height: 24px;
    margin-bottom: 20px;
}

ion-menu.ios ion-item {
    --padding-start: 16px;
    --padding-end: 16px;
    --min-height: 50px;
}

ion-menu.ios ion-item.selected ion-icon {
    color: var(--ion-color-primary);
}

ion-menu.ios ion-item ion-icon {
    font-size: 24px;
    color: #73849a;
}

ion-menu.ios ion-list#labels-list ion-list-header {
    margin-bottom: 8px;
}

ion-menu.ios ion-list-header,
ion-menu.ios ion-note {
    padding-left: 16px;
    padding-right: 16px;
}

ion-menu.ios ion-note {
    margin-bottom: 8px;
}

ion-note {
    display: inline-block;
    font-size: 16px;

    color: var(--ion-color-medium-shade);
}

ion-item.selected {
    --color: var(--ion-color-primary);
}
</style>
